Index: /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modarrays.F90
===================================================================
--- /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modarrays.F90	(revision 10086)
+++ /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modarrays.F90	(revision 10087)
@@ -55,5 +55,6 @@
                                proc_id,         &
                                coords,          &
-                               lb_tab_true, ub_tab_true, memberin )
+                               lb_tab_true, ub_tab_true, memberin,  &
+                               indminglob3,indmaxglob3)
 !---------------------------------------------------------------------------------------------------
     integer,                   intent(in)  :: nbdim         !< Number of dimensions
@@ -61,4 +62,5 @@
     integer, dimension(nbdim), intent(in)  :: ub_var        !< Local upper boundary on the current processor
     integer, dimension(nbdim), intent(in)  :: lb_tab        !< Global lower boundary of the variable
+    integer, dimension(nbdim),OPTIONAL     :: indminglob3,indmaxglob3 !< True bounds for MPI USE
     integer, dimension(nbdim), intent(in)  :: ub_tab        !< Global upper boundary of the variable
     integer,                   intent(in)  :: proc_id       !< Current processor
@@ -78,10 +80,16 @@
         call Agrif_InvLoc( lb_var(i), proc_id, coord_i, lb_glob_index )
         call Agrif_InvLoc( ub_var(i), proc_id, coord_i, ub_glob_index )
+        if (present(indminglob3)) then
+          indminglob3(i)=lb_glob_index
+          indmaxglob3(i)=ub_glob_index
+        endif
 #else
         lb_glob_index = lb_var(i)
         ub_glob_index = ub_var(i)
 #endif
+
         lb_tab_true(i) = max(lb_tab(i), lb_glob_index)
         ub_tab_true(i) = min(ub_tab(i), ub_glob_index)
+
     enddo
 !
@@ -123,5 +131,6 @@
 !
     iminmaxg(1:nbdim,2) = - iminmaxg(1:nbdim,2)
-    call MPI_ALLREDUCE(iminmaxg, lubglob, 2*nbdim, MPI_INTEGER, MPI_MIN, Agrif_mpi_comm, code)
+    call MPI_ALLREDUCE(iminmaxg, lubglob, 2*nbdim, MPI_INTEGER, MPI_MIN, &
+                       Agrif_mpi_comm, code)
     lubglob(1:nbdim,2)  = - lubglob(1:nbdim,2)
 #endif
@@ -225,5 +234,6 @@
     case (1) ; call Agrif_set_array_tozero_1D(variable%array1)
     case (2) ; call Agrif_set_array_tozero_2D(variable%array2)
-    case (3) ; call Agrif_set_array_tozero_3D(variable%array3)
+    case (3) ; call Agrif_set_array_tozero_reshape(variable%array3,size(variable%array3))
+!case (3) ; call Agrif_set_array_tozero_3D(variable%array3)
     case (4) ; call Agrif_set_array_tozero_4D(variable%array4)
     case (5) ; call Agrif_set_array_tozero_5D(variable%array5)
@@ -266,4 +276,110 @@
 !===================================================================================================
 !
+!===================================================================================================
+!
+!===================================================================================================
+!  subroutine agrif_set_array_cond
+!
+!> Compute the masking of \b variablein, according to the required dimension.
+!---------------------------------------------------------------------------------------------------
+subroutine agrif_set_array_cond ( variablein, variableout, value, nbdim )
+!---------------------------------------------------------------------------------------------------
+    type(Agrif_Variable), intent(in)    :: variablein     !< Variablein
+    type(Agrif_Variable), intent(inout) :: variableout    !< Variableout
+    real,intent(in) :: value                            !< special value
+    integer, intent(in)                 :: nbdim        !< Dimension of the array
+
+!
+    select case (nbdim)
+    case (1) ; call agrif_set_array_cond_1D(variablein%array1,variableout%array1,value)
+    case (2) ; call agrif_set_array_cond_2D(variablein%array2,variableout%array2,value)
+    case (3) ; call agrif_set_array_cond_reshape(variablein%array3,variableout%array3,value,size(variablein%array3))
+!    case (3) ; call agrif_set_array_cond_3D(variablein%array3,variableout%array3,value)
+    case (4) ; call agrif_set_array_cond_4D(variablein%array4,variableout%array4,value)
+    case (5) ; call agrif_set_array_cond_5D(variablein%array5,variableout%array5,value)
+    case (6) ; call agrif_set_array_cond_6D(variablein%array6,variableout%array6,value)
+    end select
+!---------------------------------------------------------------------------------------------------
+contains
+!---------------------------------------------------------------------------------------------------
+subroutine agrif_set_array_cond_1D(arrayin,arrayout,value)
+real,dimension(:),intent(in) :: arrayin
+real,dimension(:),intent(out) :: arrayout
+real :: value
+
+where (arrayin == value)
+  arrayout = 0.
+elsewhere
+  arrayout = 1.
+end where
+
+end subroutine agrif_set_array_cond_1D
+!
+subroutine agrif_set_array_cond_2D(arrayin,arrayout,value)
+real,dimension(:,:),intent(in) :: arrayin
+real,dimension(:,:),intent(out) :: arrayout
+real :: value
+
+where (arrayin == value)
+  arrayout = 0.
+elsewhere
+  arrayout = 1.
+end where
+
+end subroutine agrif_set_array_cond_2D
+!
+subroutine agrif_set_array_cond_3D(arrayin,arrayout,value)
+real,dimension(:,:,:),intent(in) :: arrayin
+real,dimension(:,:,:),intent(out) :: arrayout
+real :: value
+
+where (arrayin == value)
+  arrayout = 0.
+elsewhere
+  arrayout = 1.
+end where
+
+end subroutine agrif_set_array_cond_3D
+!
+subroutine agrif_set_array_cond_4D(arrayin,arrayout,value)
+real,dimension(:,:,:,:),intent(in) :: arrayin
+real,dimension(:,:,:,:),intent(out) :: arrayout
+real :: value
+
+where (arrayin == value)
+  arrayout = 0.
+elsewhere
+  arrayout = 1.
+end where
+
+end subroutine agrif_set_array_cond_4D
+!
+subroutine agrif_set_array_cond_5D(arrayin,arrayout,value)
+real,dimension(:,:,:,:,:),intent(in) :: arrayin
+real,dimension(:,:,:,:,:),intent(out) :: arrayout
+real :: value
+
+where (arrayin == value)
+  arrayout = 0.
+elsewhere
+  arrayout = 1.
+end where
+
+end subroutine agrif_set_array_cond_5D
+!
+subroutine agrif_set_array_cond_6D(arrayin,arrayout,value)
+real,dimension(:,:,:,:,:,:),intent(in) :: arrayin
+real,dimension(:,:,:,:,:,:),intent(out) :: arrayout
+real :: value
+
+where (arrayin == value)
+  arrayout = 0.
+elsewhere
+  arrayout = 1.
+end where
+
+end subroutine agrif_set_array_cond_6D
+!---------------------------------------------------------------------------------------------------
+end subroutine agrif_set_array_cond
 !===================================================================================================
 !  subroutine Agrif_var_copy_array
@@ -330,9 +446,26 @@
         real, dimension(l(1):,l(2):,l(3):), intent(out) :: tabout
         real, dimension(m(1):,m(2):,m(3):), intent(in)  :: tabin
-        tabout(inf1(1):sup1(1), &
-               inf1(2):sup1(2), &
-               inf1(3):sup1(3)) = tabin(inf2(1):sup2(1), &
-                                        inf2(2):sup2(2), &
-                                        inf2(3):sup2(3))
+        integer :: i,j,k
+
+
+!$OMP PARALLEL DO DEFAULT(none) PRIVATE(i,j,k) &
+!$OMP SHARED(inf1,inf2,sup1,sup2,tabin,tabout) &
+!$OMP SCHEDULE(RUNTIME)
+        do k=inf1(3),sup1(3)
+        do j=inf1(2),sup1(2)
+        do i=inf1(1),sup1(1)
+!          tabout(i,j,k) = tabin(i+inf2(1)-inf1(1),j+inf2(2)-inf1(2),k+inf2(3)-inf1(3))
+          tabout(i,j,k) = tabin(i,j,k)
+        enddo
+        enddo
+        enddo
+!$OMP END PARALLEL DO
+
+
+!        tabout(inf1(1):sup1(1), &
+!               inf1(2):sup1(2), &
+!               inf1(3):sup1(3)) = tabin(inf2(1):sup2(1), &
+!                                        inf2(2):sup2(2), &
+!                                        inf2(3):sup2(3))
     end subroutine Agrif_copy_array_3d
 !
@@ -631,8 +764,8 @@
     integer, dimension(6), intent(out)          :: lb_child     !< Lower bound on the child grid
     integer, dimension(6), intent(out)          :: lb_parent    !< Lower bound on the parent grid
-    real, dimension(6),    intent(out)          :: s_child      !< Child  grid position (s_root = 0)
-    real, dimension(6),    intent(out)          :: s_parent     !< Parent grid position (s_root = 0)
-    real, dimension(6),    intent(out)          :: ds_child     !< Child  grid dx (ds_root = 1)
-    real, dimension(6),    intent(out)          :: ds_parent    !< Parent grid dx (ds_root = 1)
+    real(kind=8), dimension(6),    intent(out)  :: s_child      !< Child  grid position (s_root = 0)
+    real(kind=8), dimension(6),    intent(out)  :: s_parent     !< Parent grid position (s_root = 0)
+    real(kind=8), dimension(6),    intent(out)  :: ds_child     !< Child  grid dx (ds_root = 1)
+    real(kind=8), dimension(6),    intent(out)  :: ds_parent    !< Parent grid dx (ds_root = 1)
     integer,               intent(out)          :: nbdim        !< Number of dimensions
     logical,               intent(in)           :: interp       !< .true. if preprocess for interpolation, \n
@@ -671,6 +804,6 @@
             else
                 ub_child(n) = lb_child(n) + Agrif_Child_Gr % nb(1) - 1
-                s_child(n)  = s_child(n)  + 0.5*ds_child(n)
-                s_parent(n) = s_parent(n) + 0.5*ds_parent(n)
+                s_child(n)  = s_child(n)  + 0.5d0*ds_child(n)
+                s_parent(n) = s_parent(n) + 0.5d0*ds_parent(n)
             endif
 !
@@ -689,6 +822,6 @@
             else
                 ub_child(n) = lb_child(n) + Agrif_Child_Gr % nb(2) - 1
-                s_child(n)  = s_child(n)  + 0.5*ds_child(n)
-                s_parent(n) = s_parent(n) + 0.5*ds_parent(n)
+                s_child(n)  = s_child(n)  + 0.5d0*ds_child(n)
+                s_parent(n) = s_parent(n) + 0.5d0*ds_parent(n)
             endif
 !
@@ -727,8 +860,8 @@
 !           No interpolation but only a copy of the values of the grid variable
             lb_parent(n) = lb_child(n)
-            s_child(n)   = 0.
-            s_parent(n)  = 0.
-            ds_child(n)  = 1.
-            ds_parent(n) = 1.
+            s_child(n)   = 0.d0
+            s_parent(n)  = 0.d0
+            ds_child(n)  = 1.d0
+            ds_parent(n) = 1.d0
 !
         end select
@@ -803,4 +936,11 @@
     do i = 1,nbdim
 !
+     if (coords(i) == 0) then
+       nbloc(i) = 1
+       locbounds(i,1,1) = lb_glob(i)
+       locbounds(i,2,1) = ub_glob(i)
+       locbounds(i,1,2) = lb_glob(i)
+       locbounds(i,2,2) = ub_glob(i)
+     else
         call Agrif_InvLoc(lb_var(i), rank, coords(i), i1)
 !
@@ -816,4 +956,5 @@
             endif
         enddo
+     endif
     enddo
 
@@ -825,2 +966,35 @@
 !
 end module Agrif_Arrays
+
+
+subroutine agrif_set_array_cond_reshape(arrayin,arrayout,value,n)
+integer :: n
+real,dimension(n) :: arrayin,arrayout
+real :: value
+
+integer :: i
+
+do i=1,n
+  if (arrayin(i) == value) then
+    arrayout(i) = 0.
+  else
+    arrayout(i) = 1.
+  endif
+enddo
+
+end subroutine agrif_set_array_cond_reshape
+
+subroutine agrif_set_array_tozero_reshape(array,n)
+integer :: n
+real,dimension(n) :: array
+
+integer :: i
+
+!$OMP PARALLEL DO DEFAULT(none) PRIVATE(i) &
+!$OMP SHARED(array,n)
+do i=1,n
+    array(i) = 0.
+enddo
+!$OMP END PARALLEL DO
+
+end subroutine agrif_set_array_tozero_reshape
Index: /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modbc.F90
===================================================================
--- /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modbc.F90	(revision 10086)
+++ /vendors/AGRIF/CMEMS_2020/AGRIF_FILES/modbc.F90	(revision 10087)
@@ -32,4 +32,5 @@
 !
     implicit none
+    REAL,DIMENSION(:),ALLOCATABLE :: parray_temp
 !
 contains
@@ -61,6 +62,6 @@
     integer, dimension(6)  :: loctab_child      ! Indicates if the child grid has a common border
                                                 !    with the root grid
-    real, dimension(6)     :: s_child, s_parent   ! Positions of the parent and child grids
-    real, dimension(6)     :: ds_child, ds_parent ! Space steps of the parent and child grids
+    real(kind=8), dimension(6)     :: s_child, s_parent   ! Positions of the parent and child grids
+    real(kind=8), dimension(6)     :: ds_child, ds_parent ! Space steps of the parent and child grids
 !
     call PreProcessToInterpOrUpdate( parent,   child,       &
@@ -145,6 +146,6 @@
     INTEGER, DIMENSION(nbdim)   :: posvartab_Child      !< Position of the grid variable (1 or 2)
     INTEGER, DIMENSION(nbdim)   :: loctab_Child         !< Indicates if the child grid has a common border with the root grid
-    REAL   , DIMENSION(nbdim)   :: s_Child,  s_Parent   !< Positions of the parent and child grids
-    REAL   , DIMENSION(nbdim)   :: ds_Child, ds_Parent  !< Space steps of the parent and child grids
+    REAL(kind=8)   , DIMENSION(nbdim)   :: s_Child,  s_Parent   !< Positions of the parent and child grids
+    REAL(kind=8)   , DIMENSION(nbdim)   :: ds_Child, ds_Parent  !< Space steps of the parent and child grids
     INTEGER                             :: nbdim        !< Number of dimensions of the grid variable
     procedure()                         :: procname     !< Data recovery procedure
@@ -159,9 +160,12 @@
     INTEGER,DIMENSION(nbdim,2,2,nbdim)  :: ptres,ptres2 ! calculated
     INTEGER,DIMENSION(nbdim)            :: coords
-    INTEGER                             :: i, nb, ndir
+    INTEGER                             :: i, nb, ndir,j,k,l
     INTEGER                             :: n, sizetab
     INTEGER                             :: ibeg, iend
     INTEGER                             :: i1,i2,j1,j2,k1,k2,l1,l2,m1,m2,n1,n2
     REAL                                :: c1t,c2t      ! Coefficients for the time interpolation (c2t=1-c1t)
+    INTEGER :: isize
+    INTEGER :: kindex_2d(2,nbdim)
+
 #if defined AGRIF_MPI
 !
@@ -188,5 +192,6 @@
     END WHERE
 !
-    call Agrif_get_var_global_bounds(child,lubglob,nbdim)
+!   call Agrif_get_var_global_bounds(child,lubglob,nbdim)
+    lubglob = child%lubglob(1:nbdim,:)
 !
     indtruetab(1:nbdim,1,1) = max(indtab(1:nbdim,1,1), lubglob(1:nbdim,1))
@@ -194,4 +199,5 @@
     indtruetab(1:nbdim,2,1) = min(indtab(1:nbdim,2,1), lubglob(1:nbdim,2))
     indtruetab(1:nbdim,2,2) = min(indtab(1:nbdim,2,2), lubglob(1:nbdim,2))
+	
 !
     do nb = 1,nbdim
@@ -267,4 +273,5 @@
                 if (loctab_child(nb) /= (-ndir) .AND. loctab_child(nb) /= -3) then
 !
+
                     call Agrif_InterpnD(type_interp, parent, child,             &
                                         ptres(1:nbdim,1,ndir,nb),               &
@@ -319,5 +326,6 @@
         do nb = 1,nbdim
             do ndir = 1,2
-                if (loctab_child(nb) /= (-ndir) .AND. loctab_child(nb) /= -3) then
+                kindex_2d(ndir,nb) = kindex
+                if ( (loctab_child(nb) /= (-ndir)) .AND. (loctab_child(nb) /= -3) .AND. child%memberin(nb,ndir) ) then
                     Call timeInterpolation(child,ptres2(:,:,ndir,nb),kindex,c1t,c2t,nbdim)
                 endif
@@ -325,9 +333,19 @@
         enddo
 !
-    endif
-!
     do nb = 1,nbdim
     do ndir = 1,2
         if ( (loctab_child(nb) /= (-ndir)) .AND. (loctab_child(nb) /= -3) .AND. child%memberin(nb,ndir) ) then
+
+         do i=1,nbdim
+         if (ptres2(i,1,ndir,nb) /= child%childarray(i,1,2,nb,ndir)) then
+            print *,'problem ptres2 childarray 1 ',ptres2(i,1,ndir,nb) /= child%childarray(i,1,2,nb,ndir)
+            stop
+         endif
+         if (ptres2(i,2,ndir,nb) /= child%childarray(i,2,2,nb,ndir)) then
+            print *,'problem ptres2 childarray 2 ',ptres2(i,2,ndir,nb) /= child%childarray(i,2,2,nb,ndir)
+          stop
+         endif
+         enddo
+
             select case(nbdim)
             case(1)
@@ -346,4 +364,5 @@
                               i1,i2,j1,j2, .FALSE.,coords(nb),ndir)
             case(3)
+
                 i1 = child % childarray(1,1,2,nb,ndir)
                 i2 = child % childarray(1,2,2,nb,ndir)
@@ -353,6 +372,6 @@
                 k2 = child % childarray(3,2,2,nb,ndir)
 
-                call procname(parray3(i1:i2,j1:j2,k1:k2),                   &
-                              i1,i2,j1,j2,k1,k2, .FALSE.,coords(nb),ndir)
+               call procname(parray_temp(kindex_2d(ndir,nb)),i1,i2,j1,j2,k1,k2, .FALSE.,coords(nb),ndir)
+
             case(4)
                 i1 = child % childarray(1,1,2,nb,ndir)
@@ -365,6 +384,6 @@
                 l2 = child % childarray(4,2,2,nb,ndir)
 
-                call procname(parray4(i1:i2,j1:j2,k1:k2,l1:l2),             &
-                              i1,i2,j1,j2,k1,k2,l1,l2, .FALSE.,coords(nb),ndir)
+                call procname(parray_temp(kindex_2d(ndir,nb)),i1,i2,j1,j2,k1,k2,l1,l2,.FALSE.,coords(nb),ndir)
+
             case(5)
                 i1 = child % childarray(1,1,2,nb,ndir)
@@ -401,4 +420,88 @@
     enddo
     enddo
+
+    else
+
+    do nb = 1,nbdim
+    do ndir = 1,2
+        if ( (loctab_child(nb) /= (-ndir)) .AND. (loctab_child(nb) /= -3) .AND. child%memberin(nb,ndir) ) then
+            select case(nbdim)
+            case(1)
+                i1 = child % childarray(1,1,2,nb,ndir)
+                i2 = child % childarray(1,2,2,nb,ndir)
+
+                call procname(parray1(i1:i2),                               &
+                              i1,i2, .FALSE.,coords(nb),ndir)
+            case(2)
+                i1 = child % childarray(1,1,2,nb,ndir)
+                i2 = child % childarray(1,2,2,nb,ndir)
+                j1 = child % childarray(2,1,2,nb,ndir)
+                j2 = child % childarray(2,2,2,nb,ndir)
+
+                call procname(parray2(i1:i2,j1:j2),                         &
+                              i1,i2,j1,j2, .FALSE.,coords(nb),ndir)
+            case(3)
+
+                i1 = child % childarray(1,1,2,nb,ndir)
+                i2 = child % childarray(1,2,2,nb,ndir)
+                j1 = child % childarray(2,1,2,nb,ndir)
+                j2 = child % childarray(2,2,2,nb,ndir)
+                k1 = child % childarray(3,1,2,nb,ndir)
+                k2 = child % childarray(3,2,2,nb,ndir)
+
+                call procname(parray3(i1:i2,j1:j2,k1:k2),                   &
+                              i1,i2,j1,j2,k1,k2, .FALSE.,coords(nb),ndir)
+
+            case(4)
+                i1 = child % childarray(1,1,2,nb,ndir)
+                i2 = child % childarray(1,2,2,nb,ndir)
+                j1 = child % childarray(2,1,2,nb,ndir)
+                j2 = child % childarray(2,2,2,nb,ndir)
+                k1 = child % childarray(3,1,2,nb,ndir)
+                k2 = child % childarray(3,2,2,nb,ndir)
+                l1 = child % childarray(4,1,2,nb,ndir)
+                l2 = child % childarray(4,2,2,nb,ndir)
+
+                call procname(parray4(i1:i2,j1:j2,k1:k2,l1:l2),             &
+                              i1,i2,j1,j2,k1,k2,l1,l2, .FALSE.,coords(nb),ndir)
+
+            case(5)
+                i1 = child % childarray(1,1,2,nb,ndir)
+                i2 = child % childarray(1,2,2,nb,ndir)
+                j1 = child % childarray(2,1,2,nb,ndir)
+                j2 = child % childarray(2,2,2,nb,ndir)
+                k1 = child % childarray(3,1,2,nb,ndir)
+                k2 = child % childarray(3,2,2,nb,ndir)
+                l1 = child % childarray(4,1,2,nb,ndir)
+                l2 = child % childarray(4,2,2,nb,ndir)
+                m1 = child % childarray(5,1,2,nb,ndir)
+                m2 = child % childarray(5,2,2,nb,ndir)
+
+                call procname(parray5(i1:i2,j1:j2,k1:k2,l1:l2,m1:m2),       &
+                              i1,i2,j1,j2,k1,k2,l1,l2,m1,m2, .FALSE.,coords(nb),ndir)
+            case(6)
+                i1 = child % childarray(1,1,2,nb,ndir)
+                i2 = child % childarray(1,2,2,nb,ndir)
+                j1 = child % childarray(2,1,2,nb,ndir)
+                j2 = child % childarray(2,2,2,nb,ndir)
+                k1 = child % childarray(3,1,2,nb,ndir)
+                k2 = child % childarray(3,2,2,nb,ndir)
+                l1 = child % childarray(4,1,2,nb,ndir)
+                l2 = child % childarray(4,2,2,nb,ndir)
+                m1 = child % childarray(5,1,2,nb,ndir)
+                m2 = child % childarray(5,2,2,nb,ndir)
+                n1 = child % childarray(6,1,2,nb,ndir)
+                n2 = child % childarray(6,2,2,nb,ndir)
+
+                call procname(parray6(i1:i2,j1:j2,k1:k2,l1:l2,m1:m2,n1:n2), &
+                              i1,i2,j1,j2,k1,k2,l1,l2,m1,m2,n1,n2, .FALSE.,coords(nb),ndir)
+            end select
+        endif
+    enddo
+    enddo
+
+    endif
+!
+
 !---------------------------------------------------------------------------------------------------
 end subroutine Agrif_Correctnd
@@ -525,4 +628,27 @@
 !
     INTEGER :: ir,jr,kr,lr,mr,nr
+    INTEGER :: kindexmax, isize,i
+    REAL,DIMENSION(:),ALLOCATABLE :: tabtemp
+
+    isize = 1
+    DO i=1,nbdim
+      isize = isize * (bounds(i,2)-bounds(i,1)+1)
+    ENDDO
+    IF (isize <= 0) RETURN
+
+    kindexmax = kindex + isize - 1
+    IF (.NOT.ALLOCATED(parray_temp)) THEN
+      ALLOCATE(parray_temp(kindexmax)) 
+    ELSE 
+      IF (size(parray_temp) < kindexmax) THEN
+         ALLOCATE(tabtemp(size(parray_temp)))
+         tabtemp = parray_temp
+         DEALLOCATE(parray_temp)
+         ALLOCATE(parray_temp(kindexmax))
+         parray_temp(1:size(tabtemp)) = tabtemp
+         DEALLOCATE(tabtemp)
+      ENDIF
+    ENDIF
+ 
 !
     SELECT CASE (nbdim)
@@ -546,28 +672,14 @@
 !
     CASE (3)
-        do kr = bounds(3,1),bounds(3,2)
-        do jr = bounds(2,1),bounds(2,2)
-!CDIR ALTCODE
-        do ir = bounds(1,1),bounds(1,2)
-            parray3(ir,jr,kr) = c2t*child_var % oldvalues2d(1,kindex) + &
-                                            c1t*child_var % oldvalues2d(2,kindex)
-            kindex = kindex + 1
-        enddo
-        enddo
-        enddo
+
+        parray_temp(kindex:kindexmax) = c2t*child_var % oldvalues2d(1,kindex:kindexmax) + &
+                                        c1t*child_var % oldvalues2d(2,kindex:kindexmax)
+
 !
     CASE (4)
-        do lr = bounds(4,1),bounds(4,2)
-        do kr = bounds(3,1),bounds(3,2)
-        do jr = bounds(2,1),bounds(2,2)
-!CDIR ALTCODE
-        do ir = bounds(1,1),bounds(1,2)
-            parray4(ir,jr,kr,lr) = c2t*child_var % oldvalues2d(1,kindex) + &
-                                               c1t*child_var % oldvalues2d(2,kindex)
-            kindex = kindex + 1
-        enddo
-        enddo
-        enddo
-        enddo
+
+        parray_temp(kindex:kindexmax) = c2t*child_var % oldvalues2d(1,kindex:kindexmax) + &
+                                        c1t*child_var % oldvalues2d(2,kindex:kindexmax)
+
 !
     CASE (5)
@@ -605,4 +717,7 @@
         enddo
     END SELECT
+
+    kindex = kindexmax + 1
+
 !---------------------------------------------------------------------------------------------------
 end subroutine timeInterpolation
